diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/fat32filesystem.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/fat32filesystem.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/fat32filesystem.cpp	2010-05-10 19:22:13.769118155 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/fat32filesystem.cpp	2010-05-08 14:41:04.000000000 +0100
@@ -21,6 +21,7 @@
 */
 
 #include"fat32filesystem.h"
+#include <cstring>
 
 /**
 Initializes the boot sector of a FAT 32 volume
@@ -90,59 +91,59 @@
 	//copying of boot sector values in to the array
 	iData = new unsigned char[BytesPerSector];
 	unsigned int pos = 0;
-	memcpy(&iData[pos],JmpBoot,3);
+	memmove(&iData[pos],JmpBoot,3);
 	pos += 3;
-	memcpy(&iData[pos],OEMName,8);
+	memmove(&iData[pos],OEMName,8);
 	pos += 8;
-	memcpy(&iData[pos],&BytesPerSector,2);
+	memmove(&iData[pos],&BytesPerSector,2);
 	pos += 2;
-	memcpy(&iData[pos],&SectorsPerCluster,1);
+	memmove(&iData[pos],&SectorsPerCluster,1);
 	pos += 1;
-	memcpy(&iData[pos],&ReservedSectors,2);
+	memmove(&iData[pos],&ReservedSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&NumFats,1);
+	memmove(&iData[pos],&NumFats,1);
 	pos += 1;
-	memcpy(&iData[pos],&RootDirEntries,2);
+	memmove(&iData[pos],&RootDirEntries,2);
 	pos += 2;
-	memcpy(&iData[pos],&LowSectors,2);
+	memmove(&iData[pos],&LowSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&Media,1);
+	memmove(&iData[pos],&Media,1);
 	pos += 1;
-	memcpy(&iData[pos],&FatSectors,2);
+	memmove(&iData[pos],&FatSectors,2);
 	pos += 2;
-	memcpy(&iData[pos],&SectorPerTrack,2);
+	memmove(&iData[pos],&SectorPerTrack,2);
 	pos += 2;
-	memcpy(&iData[pos],&NumberOfHeads,2);
+	memmove(&iData[pos],&NumberOfHeads,2);
 	pos += 2;
-	memcpy(&iData[pos],&HiddenSectors,4);
+	memmove(&iData[pos],&HiddenSectors,4);
 	pos += 4;
-	memcpy(&iData[pos],&HighSectorsCount,4);
+	memmove(&iData[pos],&HighSectorsCount,4);
 	pos += 4;
-	memcpy(&iData[pos],&FatSectors32,4);
+	memmove(&iData[pos],&FatSectors32,4);
 	pos += 4;
-	memcpy(&iData[pos],&ExtFlags,2);
+	memmove(&iData[pos],&ExtFlags,2);
 	pos += 2;
-	memcpy(&iData[pos],&FileSystemVersion,2);
+	memmove(&iData[pos],&FileSystemVersion,2);
 	pos += 2;
-	memcpy(&iData[pos],&RootCluster,4);
+	memmove(&iData[pos],&RootCluster,4);
 	pos += 4;
-	memcpy(&iData[pos],&FSInfo,2);
+	memmove(&iData[pos],&FSInfo,2);
 	pos += 2;
-	memcpy(&iData[pos],&BackUpBootSector,2);
+	memmove(&iData[pos],&BackUpBootSector,2);
 	pos += 2;
-	memcpy(&iData[pos],FutureReserved,12);
+	memmove(&iData[pos],FutureReserved,12);
 	pos += 12;
-	memcpy(&iData[pos],&BootSectorDriveNumber,1);
+	memmove(&iData[pos],&BootSectorDriveNumber,1);
 	pos += 1;
-	memcpy(&iData[pos],&ReservedByte,1);
+	memmove(&iData[pos],&ReservedByte,1);
 	pos += 1;
-	memcpy(&iData[pos],&BootSignature,1);
+	memmove(&iData[pos],&BootSignature,1);
 	pos += 1;
-	memcpy(&iData[pos],&VolumeId,4);
+	memmove(&iData[pos],&VolumeId,4);
 	pos += 4;
-	memcpy(&iData[pos],VolumeLab,11);
+	memmove(&iData[pos],VolumeLab,11);
 	pos += 11;
-	memcpy(&iData[pos],FileSystemType,8);
+	memmove(&iData[pos],FileSystemType,8);
 	pos += 8;
 	while(pos < BytesPerSector)
 	{
@@ -159,7 +160,7 @@
 	ComputeClusterSizeInBytes();
 	ComputeRootDirSectors();
 	ComputeBytesPerSector();
-	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORCREATEMSG, "FAT32");
+	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORCREATEMSG, const_cast<char *>("FAT32"));
 }
 
 /**
@@ -172,7 +173,7 @@
 */
 void CFat32FileSystem::WriteBootSector(ofstream& aOutPutStream)
 {
-	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORWRITEMSG, "FAT32");
+	MessageHandler::ReportMessage (INFORMATION,BOOTSECTORWRITEMSG, const_cast<char *>("FAT32"));
 	aOutPutStream.write(reinterpret_cast<char*>(&iData[0]),iFAT32BootSector.BytesPerSector());
 	aOutPutStream.flush();
 }
@@ -228,8 +229,9 @@
 		// Each FAT32 entries occupies 4 bytes, hence multiply by 4
 		aFatString.append((totalFatEntries - clusterCounter)*4, 0);
 	}
-	MessageHandler::ReportMessage (INFORMATION,FATTABLEWRITEMSG,
-								   "FAT32");
+
+	MessageHandler::ReportMessage (INFORMATION,FATTABLEWRITEMSG,const_cast<char *>("FAT32"));
+
 	//Write FAT table multiple times depending on the value of No of FATS set.
 	unsigned int noOfFats = iFAT32BootSector.NumberOfFats();
 	for(unsigned int i=0; i<noOfFats; i++)
@@ -254,19 +256,19 @@
 	unsigned int bytesPerSector = iFAT32BootSector.BytesPerSector();
 	FSinfoData = new unsigned char[bytesPerSector];
 	iFSInfo.SetFSInfo();
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_LeadSign,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_LeadSign,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Reserved,480);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Reserved,480);
 	counter += 480;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_StrucSig,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_StrucSig,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Free_Count,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Free_Count,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Nxt_Free,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Nxt_Free,4);
 	counter += 4;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_Reserved2,12);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_Reserved2,12);
 	counter += 12;
-	memcpy(&FSinfoData[counter], &iFSInfo.FSI_TrailSig,4);
+	memmove(&FSinfoData[counter], &iFSInfo.FSI_TrailSig,4);
 	counter += 4;
 	counter += (bytesPerSector-KSizeOfFatBootSector);
 	aOutPutStream.write(reinterpret_cast<char*>(&FSinfoData[0]),counter);
@@ -367,11 +369,15 @@
  	iTotalClusters = totalDataSectors / iFAT32BootSector.SectorsPerCluster();
 	if(iTotalClusters < KMinimumFat32Clusters)
 	{
-		throw ErrorHandler(BOOTSECTORERROR,"Low Partition Size",__FILE__, __LINE__);
+		throw ErrorHandler(BOOTSECTORERROR,
+			const_cast<char *>("Low Partition Size"),
+			const_cast<char *>(__FILE__), __LINE__);
 	}
 	else if(iTotalClusters > KMaximumFat32Clusters)
 	{
-		throw ErrorHandler(BOOTSECTORERROR,"high Partition Size",__FILE__, __LINE__);
+		throw ErrorHandler(BOOTSECTORERROR,
+			const_cast<char *>("high Partition Size"),
+			const_cast<char *>(__FILE__), __LINE__);
 	}
 }
 /**
@@ -424,7 +430,7 @@
 	{
 		delete dirRegionPtr;
 		dirRegionPtr = NULL;
-		throw ErrorHandler(UNKNOWNERROR, __FILE__, __LINE__);
+		throw ErrorHandler(UNKNOWNERROR, const_cast<char *>(__FILE__), __LINE__);
 	}
 }
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp	2010-05-10 19:22:13.769118155 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/fatbasebootsector.cpp	2010-05-08 14:43:16.000000000 +0100
@@ -22,6 +22,7 @@
 */
 
 #include "fatbasebootsector.h"
+#include <cstring>
 
 /**
 Constructor of the base boot sector class
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/filesysteminterface.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/filesysteminterface.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/filesysteminterface.cpp	2010-05-10 19:22:13.773117267 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/filesysteminterface.cpp	2010-05-08 14:41:36.000000000 +0100
@@ -62,7 +62,9 @@
 		iOutputStream.open(aImageFileName,ios::out|ios::binary);
 		if(iOutputStream.fail() == true )
 		{
-			throw ErrorHandler(FILEOPENERROR,aImageFileName,__FILE__, __LINE__);
+			throw ErrorHandler(FILEOPENERROR,
+				const_cast<char *>(aImageFileName),
+				const_cast<char *>(__FILE__), __LINE__);
 		}
 		switch(aFileSystem)
 		{
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/longname.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/longname.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/longname.cpp	2010-05-10 19:22:13.773117267 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/longname.cpp	2010-05-08 14:45:46.000000000 +0100
@@ -21,6 +21,7 @@
 
 
 #include "longname.h"
+#include <cstring>
 
 
 /** 
@@ -48,7 +49,7 @@
 	iLongNameLength = iLongName.length();
 	if(iLongNameLength == 0)
 	{
-		throw ErrorHandler(EMPTYFILENAME, __FILE__, __LINE__);
+		throw ErrorHandler(EMPTYFILENAME, const_cast<char *>(__FILE__), __LINE__);
 	}
 	FormatLongFileName(iLongName);
 	iShortName = GetShortEntryName();
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/messageimplementation.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/messageimplementation.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/filesystem/source/messageimplementation.cpp	2010-05-10 19:22:13.773117267 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/filesystem/source/messageimplementation.cpp	2010-05-08 14:49:08.000000000 +0100
@@ -23,15 +23,17 @@
 
 #include "messageimplementation.h"
 #include "errorhandler.h"
+#include <cstring>
 
 using std::endl;
 using std::cout;
 typedef std::string String;
 
-char *errorMssgPrefix="FileSystem : Error:";
-char *warnMssgPrefix="FileSystem : Warning:";
-char *infoMssgPrefix="FileSystem : Information:";
-char *Space=" ";
+char const *errorMssgPrefix="FileSystem : Error:";
+char const *warnMssgPrefix="FileSystem : Warning:";
+char const *infoMssgPrefix="FileSystem : Information:";
+char const *Space=" ";
+
 
 enum MessageArraySize{MAX=16};
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/host/h_utl.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/host/h_utl.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/host/h_utl.cpp	2010-05-10 19:22:13.777117566 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/host/h_utl.cpp	2010-05-08 14:36:18.000000000 +0100
@@ -177,7 +177,7 @@
 
 
 	TInt build=0;
-	memset(&aVersion, sizeof(TVersion), 0);	
+	memset(&aVersion, 0, sizeof(TVersion));
 	TInt i;
 	TInt len=strlen(str);
 	for (i=0; i<len; i++)
@@ -192,7 +192,7 @@
 		{ 
 		cout << "\n Warning: major version must be in range 0 - 127 \n";
 		}
-	char* pMinor = strchr(str, '.');
+	char const * pMinor = strchr(str, '.');
 	if (pMinor)
 		{
 		pMinor++; 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/inc/h_utl.h /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/inc/h_utl.h
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/inc/h_utl.h	2010-05-10 19:22:13.777117566 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/inc/h_utl.h	2010-05-08 14:39:00.000000000 +0100
@@ -65,9 +65,6 @@
 #define _stricmp strcasecmp		
 #define strnicmp strncasecmp	
 
-// to fix the linux problem: memcpy does not work with overlapped areas.
-#define memcpy memmove
-
 // hand-rolled strupr function for converting a string to all uppercase
 char* strupr(char *a);
 
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp	2010-05-10 19:22:13.781117167 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/imglib/parameterfileprocessor/source/parameterfileprocessor.cpp	2010-05-08 14:35:28.000000000 +0100
@@ -21,6 +21,7 @@
 
 
 #include "parameterfileprocessor.h"
+#include <cstring>
 
 
 /**
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/group/BLD.INF /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/group/BLD.INF
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/group/BLD.INF	2010-05-10 19:22:13.781117167 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/group/BLD.INF	2010-04-29 15:03:58.000000000 +0100
@@ -15,13 +15,14 @@
 *
 */
 
+#include <productvariant.hrh>
 
 PRJ_PLATFORMS
 TOOLS2
 
 PRJ_EXPORTS
 
-../maksym/fixupsym.bat              /epoc32/tools/fixupsym.bat
+../maksym/fixupsym.bat              EPOCROOT_EXPORT_PATH(epoc32/tools/fixupsym.bat)
 ../maksym/hpsym.bat                 /epoc32/tools/hpsym.bat
 ../maksym/maksym.bat                /epoc32/tools/maksym.bat
 ../maksym/maksymrofs.bat            /epoc32/tools/maksymrofs.bat
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/group/readimage.mmp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/group/readimage.mmp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/group/readimage.mmp	2010-05-10 19:22:13.781117167 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/group/readimage.mmp	2010-05-08 14:49:50.000000000 +0100
@@ -45,15 +45,16 @@
 userinclude     ..\..\imglib\compress 
 userinclude		..\..\imglib\patchdataprocessor\include
 userinclude		..\..\sisutils\inc
+#ifndef TOOLS2_LINUX
 userinclude   ..\..\imglib\boostlibrary
+#endif
 
 USERINCLUDE ..\..\imglib\inc
 OS_LAYER_SYSTEMINCLUDE_SYMBIAN
 
 staticlibrary 	sisutils
 #ifdef TOOLS2_LINUX
-STATICLIBRARY   boost_thread-mgw34-mt-1_39_linux
-OPTION    GCC -pthread -O2 -Wno-uninitialized
+OPTION    GCC -pthread -O2 -Wno-uninitialized -lboost_thread-mt
 #else
 STATICLIBRARY   boost_thread-mgw34-mt-1_39_win32
 OPTION    GCC -mthreads -O2 -Wno-uninitialized
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/inc/common.h /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/inc/common.h
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/inc/common.h	2010-05-10 19:22:13.785117675 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/inc/common.h	2010-05-08 15:01:02.000000000 +0100
@@ -46,7 +46,7 @@
 #define DLL_UID1	10000079
 #define EXE_UID1	1000007a
 
-typedef enum EImageType
+enum EImageType
 {
 	EUNKNOWN_IMAGE,
 	EROM_IMAGE,
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/inc/image_reader.h /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/inc/image_reader.h
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/inc/image_reader.h	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/inc/image_reader.h	2010-05-08 15:02:34.000000000 +0100
@@ -27,7 +27,19 @@
 
 
 #include "common.h"
-#include <direct.h>
+#if defined(WIN32)
+	#include <direct.h>
+	#define GETCWD	_getcwd
+	#define CHDIR	_chdir
+	#define MKDIR(dir)	_mkdir(dir)
+#elif defined(__LINUX__)
+	#include <sys/stat.h>
+	#include <unistd.h>
+	#define GETCWD	getcwd
+	#define CHDIR	chdir
+	#define MKDIR(dir)	mkdir((dir),S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH)
+#endif
+
 #include <map>
 
 typedef struct tag_FILEINFO
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/inc/rofs_image_reader.h /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/inc/rofs_image_reader.h
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/inc/rofs_image_reader.h	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/inc/rofs_image_reader.h	2010-05-08 15:01:40.000000000 +0100
@@ -65,7 +65,7 @@
 	void DumpDirStructure();
 	void DumpFileAttributes();
 	void MarkNodes();
-	void SetSeek(streampos aOff, ios::seek_dir aStartPos=ios::beg);
+	void SetSeek(streampos aOff, std::ios_base::seekdir aStartPos);
 	void ExtractImageContents();
 	void CheckFileExtension(char* aFileName,TRomBuilderEntry* aEntry,TRomNode* aNode,ofstream& aLogFile );
 	void GetCompleteNodePath(TRomNode* aNode,string& aName,char* aAppStr);
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/e32_image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/e32_image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/e32_image_reader.cpp	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/e32_image_reader.cpp	2010-05-08 15:00:20.000000000 +0100
@@ -74,27 +74,27 @@
 {
 	bool aContinue = true;
 
-	DumpInHex("Size", aE32Image.iSize ) << endl;
-	DumpInHex("Uids",aE32Image.iOrigHdr->iUid1);
-	DumpInHex(" ",aE32Image.iOrigHdr->iUid2, aContinue);
-	DumpInHex(" ",aE32Image.iOrigHdr->iUid3, aContinue);
-	DumpInHex(" ",aE32Image.iOrigHdr->iUidChecksum, aContinue) << endl;
-
-	
-	DumpInHex("Entry point", aE32Image.iOrigHdr->iEntryPoint ) << endl;
-	DumpInHex("Code start addr" ,aE32Image.iOrigHdr->iCodeBase)<< endl;
-	DumpInHex("Data start addr" ,aE32Image.iOrigHdr->iDataBase) << endl;
-	DumpInHex("Text size" ,aE32Image.iOrigHdr->iTextSize) << endl;
-	DumpInHex("Code size" ,aE32Image.iOrigHdr->iCodeSize) << endl;
-	DumpInHex("Data size" ,aE32Image.iOrigHdr->iDataSize) << endl;
-	DumpInHex("Bss size" ,aE32Image.iOrigHdr->iBssSize) << endl;
-	DumpInHex("Total data size" ,(aE32Image.iOrigHdr->iBssSize + aE32Image.iOrigHdr->iDataSize)) << endl;
-	DumpInHex("Heap min" ,aE32Image.iOrigHdr->iHeapSizeMin) << endl;
-	DumpInHex("Heap max" ,aE32Image.iOrigHdr->iHeapSizeMax) << endl;
-	DumpInHex("Stack size" ,aE32Image.iOrigHdr->iStackSize) << endl;
-	DumpInHex("Export directory" ,aE32Image.iOrigHdr->iExportDirOffset) << endl;
-	DumpInHex("Export dir count" ,aE32Image.iOrigHdr->iExportDirCount) << endl;
-	DumpInHex("Flags" ,aE32Image.iOrigHdr->iFlags) << endl;
+	DumpInHex(const_cast<char *>("Size"), aE32Image.iSize ) << endl;
+	DumpInHex(const_cast<char *>("Uids"),aE32Image.iOrigHdr->iUid1);
+	DumpInHex(const_cast<char *>(" "),aE32Image.iOrigHdr->iUid2, aContinue);
+	DumpInHex(const_cast<char *>(" "),aE32Image.iOrigHdr->iUid3, aContinue);
+	DumpInHex(const_cast<char *>(" "),aE32Image.iOrigHdr->iUidChecksum, aContinue) << endl;
+
+	
+	DumpInHex(const_cast<char *>("Entry point"), aE32Image.iOrigHdr->iEntryPoint ) << endl;
+	DumpInHex(const_cast<char *>("Code start addr") ,aE32Image.iOrigHdr->iCodeBase)<< endl;
+	DumpInHex(const_cast<char *>("Data start addr") ,aE32Image.iOrigHdr->iDataBase) << endl;
+	DumpInHex(const_cast<char *>("Text size") ,aE32Image.iOrigHdr->iTextSize) << endl;
+	DumpInHex(const_cast<char *>("Code size") ,aE32Image.iOrigHdr->iCodeSize) << endl;
+	DumpInHex(const_cast<char *>("Data size") ,aE32Image.iOrigHdr->iDataSize) << endl;
+	DumpInHex(const_cast<char *>("Bss size") ,aE32Image.iOrigHdr->iBssSize) << endl;
+	DumpInHex(const_cast<char *>("Total data size") ,(aE32Image.iOrigHdr->iBssSize + aE32Image.iOrigHdr->iDataSize)) << endl;
+	DumpInHex(const_cast<char *>("Heap min") ,aE32Image.iOrigHdr->iHeapSizeMin) << endl;
+	DumpInHex(const_cast<char *>("Heap max") ,aE32Image.iOrigHdr->iHeapSizeMax) << endl;
+	DumpInHex(const_cast<char *>("Stack size") ,aE32Image.iOrigHdr->iStackSize) << endl;
+	DumpInHex(const_cast<char *>("Export directory") ,aE32Image.iOrigHdr->iExportDirOffset) << endl;
+	DumpInHex(const_cast<char *>("Export dir count") ,aE32Image.iOrigHdr->iExportDirCount) << endl;
+	DumpInHex(const_cast<char *>("Flags") ,aE32Image.iOrigHdr->iFlags) << endl;
 
 	TUint aHeaderFmt = E32ImageHeader::HdrFmtFromFlags(aE32Image.iOrigHdr->iFlags);
 
@@ -105,10 +105,10 @@
 		// because this is relied on by used by "Symbian Signed".
 		//
 		E32ImageHeaderV* v = aE32Image.iHdr;
-		DumpInHex("Secure ID", v->iS.iSecureId) << endl;
-		DumpInHex("Vendor ID", v->iS.iVendorId) << endl;
-		DumpInHex("Capability", v->iS.iCaps[1]);
-		DumpInHex(" ", v->iS.iCaps[0], aContinue) << endl;
+		DumpInHex(const_cast<char *>("Secure ID"), v->iS.iSecureId) << endl;
+		DumpInHex(const_cast<char *>("Vendor ID"), v->iS.iVendorId) << endl;
+		DumpInHex(const_cast<char *>("Capability"), v->iS.iCaps[1]);
+		DumpInHex(const_cast<char *>(" "), v->iS.iCaps[0], aContinue) << endl;
 
 	}
 
@@ -119,15 +119,17 @@
 	*out << "(" << dec << aE32Image.iOrigHdr->iToolsVersion.iBuild << ")" << endl;
 
 	*out << "Module Version.............." << dec << (aE32Image.iOrigHdr->iModuleVersion >> 16) << endl;
-	DumpInHex("Compression", aE32Image.iOrigHdr->iCompressionType) << endl;
+	DumpInHex(const_cast<char *>("Compression"), aE32Image.iOrigHdr->iCompressionType) << endl;
 
 	if( aHeaderFmt >= KImageHdrFmt_V )
 	{
 		E32ImageHeaderV* v = aE32Image.iHdr;
-		DumpInHex("Exception Descriptor", v->iExceptionDescriptor) << endl;
-		DumpInHex("Code offset", v->iCodeOffset) << endl;
+		DumpInHex(const_cast<char *>("Exception Descriptor"), v->iExceptionDescriptor) << endl;
+		DumpInHex(const_cast<char *>("Code offset"), v->iCodeOffset) << endl;
+
 	}
 
 	*out << "Priority...................." << dec << aE32Image.iOrigHdr->iProcessPriority << endl;
-	DumpInHex("Dll ref table size", aE32Image.iOrigHdr->iDllRefTableCount) << endl << endl << endl;
+	DumpInHex(const_cast<char *>("Dll ref table size"), aE32Image.iOrigHdr->iDllRefTableCount) << endl << endl << endl;
 }
+
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/image_handler.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/image_handler.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/image_handler.cpp	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/image_handler.cpp	2010-05-08 14:59:02.000000000 +0100
@@ -392,7 +392,8 @@
 	{
 		if(iInputFileName.empty())
 		{
-			throw SisUtilsException("Usage Error", "No SIS file passed");
+			throw SisUtilsException(const_cast<char *>("Usage Error"),
+				const_cast<char *>("No SIS file passed"));
 		}
 
 		iSisUtils = new Sis2Iby((char*)iInputFileName.c_str());
@@ -409,7 +410,8 @@
 		}
 		else
 		{
-			throw SisUtilsException("Error:", "Cannot create Sis2Iby object");
+			throw SisUtilsException(const_cast<char *>("Error:"),
+				const_cast<char *>("Cannot create Sis2Iby object"));
 		}
 	}
 }
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/image_reader.cpp	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/image_reader.cpp	2010-05-08 14:57:10.000000000 +0100
@@ -173,7 +173,7 @@
 
 
 	// get the current working directory and store in buffer.
-	if( _getcwd(currWorkingDir,_MAX_BUFFER_SIZE_) == NULL )
+	if( GETCWD(currWorkingDir,_MAX_BUFFER_SIZE_) == NULL )
 	{
 		// throw an exception if unable to get current working directory information.
 		throw ImageReaderException((char*)ImageReader::iImgFileName.c_str(), "Failed to get the current working directory");
@@ -191,7 +191,7 @@
 			changeToDrive.append(aDelimiter);
 			
 			// change the current working directory to the specified directory.
-			if( _chdir(changeToDrive.c_str()) )
+			if( CHDIR(changeToDrive.c_str()) )
 			{
 				// throw an exception if unable to change the directory specified.
 				throw ImageReaderException((char*)ImageReader::iImgFileName.c_str(), "Failed to change to the directory specified");
@@ -200,23 +200,23 @@
 		else
 		{
 			// if not,then create a cPtr directory. 
-			_mkdir(cPtr);
+			MKDIR(cPtr);
 			// change the current working directory to cPtr.
-			_chdir(cPtr);
+			int r = CHDIR(cPtr); (void)r;
 		}
 		// repeat till cPtr is NULL.
 		while (cPtr!=NULL)
 		{
-			if (cPtr = strtok(NULL,aDelimiter))
+			if ((cPtr = strtok(NULL,aDelimiter)) != NULL)
 			{
 				// create the directory.
-				_mkdir(cPtr);
+				MKDIR(cPtr);
 				// change current working directory.
-				_chdir(cPtr);
+				int r = CHDIR(cPtr); (void)r;
 			}
 		}
 		// revert back the working directory.
-		_chdir(currWorkingDir);
+		int r = CHDIR(currWorkingDir); (void)r;
 		// replace the source path with the original path information.
 		strcpy(aSrcPath,origPath.c_str());
 		delete[] currWorkingDir;
diff -u -r -b -B -E -x '*.hg*' -x '*cross-plat-dev-utils*' -x '*baseline.txt' -x '*README' -x '*TODO' -x '*NEWS' -x '*.pyc' -x '*~' -x '*linux-unknown-libc2_11*' /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/rofs_image_reader.cpp /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/rofs_image_reader.cpp
--- /home/imk/symbian/epocroot-pdk-3.0.h/build_latest/build/imgtools/romtools/readimage/src/rofs_image_reader.cpp	2010-05-10 19:22:13.789117416 +0100
+++ /home/imk/symbian/epocroot-pdk-3.0.h/build/imgtools/romtools/readimage/src/rofs_image_reader.cpp	2010-05-08 14:58:12.000000000 +0100
@@ -42,7 +42,7 @@
 	delete iImageReader;
 }
 
-void RofsImageReader::SetSeek(streampos aOff, ios::seek_dir aStartPos)
+void RofsImageReader::SetSeek(streampos aOff, std::ios_base::seekdir aStartPos)
 {
 	if(!iInputFile)
 		return;
@@ -290,7 +290,7 @@
 
 			*out << "********************************************************************" << endl;
 			iPath.assign((char*)aNode->iName);	
-			GetCompleteNodePath(aNode,iPath,"/");
+			GetCompleteNodePath(aNode,iPath,const_cast<char *>("/"));
 			*out << "File........................" << iPath.c_str() << endl;
 			if( aNode->iEntry->iExecutable )
 			{
@@ -417,7 +417,8 @@
 	{
 		// get the complete path 
 		path.assign( (char*)aNode->iName );
-		GetCompleteNodePath( aNode, path, "\\\\" );
+		GetCompleteNodePath( aNode, path, const_cast<char *>("\\\\") );
+
 	}
 	else
 	{
@@ -496,7 +497,7 @@
 	{
 		// get the complete path 
 		path.assign( (char*)aNode->iName );
-		GetCompleteNodePath( aNode, path, "\\" );
+		GetCompleteNodePath( aNode, path, const_cast<char *>("\\") );
 	}
 	else
 	{
